Bug 740042 - pass boot performance data to OS
Summary: pass boot performance data to OS
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: grub
Version: 19
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Peter Jones
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-09-20 19:04 UTC by Lennart Poettering
Modified: 2015-02-17 13:53 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-02-17 13:53:35 UTC


Attachments (Terms of Use)

Description Lennart Poettering 2011-09-20 19:04:59 UTC
At the plumbers conference this came up, so here's a wishlist bug:

Right now in systemd at every boot we print the time the boot process took, split up into three values: kernel, initrd, userspace. I'd like to extend this to two more values: firmware and boot loader. 

The CoreBoot folks suggested we should simply invoke RDTSC once very early in the grub boot code, and store that away in memory. And then after loading the kernel and the initrd into RAM, right before jumping into the kernel code call it another time. Since the TSC starts counting at 0 very early in the firmware we thus can calculate the time spent in the BIOS and in the boot loader. The two TSC values then would need to be passed to the OS in some way. An easy way would be as parameters on the kernel cmdline ("grub.start_tsc=..." and "grub.end_tsc=..." or so.

TSC data can be skewed when used in SMP and in conjunction with certain power management features. However, the CoreBoot folks clarified that this should have little effect until the OS is up, since neither SMP nor PM is used that early and the accuracy needed for this information is very low.

It would be the job of the Linux userspace to convert the TSC values into seconds.

Comment 1 Fedora End Of Life 2013-04-03 17:02:50 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19

Comment 2 Fedora End Of Life 2015-01-09 16:47:31 UTC
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 3 Fedora End Of Life 2015-02-17 13:53:35 UTC
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.